"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isValidJson = exports.parseHeaderFlag = exports.escapeStringTemplateTicks = void 0;
const escapeStringTemplateTicks = (str) => str.replace(/`/g, `\\\``); // lgtm [js/incomplete-sanitization]
exports.escapeStringTemplateTicks = escapeStringTemplateTicks;
const parseHeaderFlag = (headerFlag) => {
    const headers = {};
    for (const header of headerFlag || []) {
        const [name, value] = header.split(':');
        headers[name.trim()] = value.trim();
    }
    return headers;
};
exports.parseHeaderFlag = parseHeaderFlag;
const isValidJson = (jsonString) => {
    try {
        JSON.parse(jsonString);
        return true;
    }
    catch {
        return false;
    }
};
exports.isValidJson = isValidJson;
